package ex1;

import java.util.Comparator;

/**
 *	Class that represents a person.
 */

public class Person {
	
	// protected not private, because subclasses may need it (any person has a name)
	protected String name;
	
	public Person(){
		name = "";
	}
	
	public Person(String name){
		this.name = name;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	/**
	 * {@link java.util.Comparator Comparator} implementation for comparing persons based on their names.
	 */
	public class NameComparator implements Comparator<Person> {

		/**
		 * Compares two persons' names for ascending order sorting.
		 * @param o1 the first Person to be compared
		 * @param o2 the second Person to be compared
		 * @return a negative integer, zero, or a positive integer as the first
		 *         argument is less than, equal to, or greater than the second.
		 */
		@Override
		public int compare(Person o1, Person o2) {
			// compare names for ascending order sorting
			return o1.getName().compareTo(o2.getName());			
		}		
	}
	
	/**
	 * {@link java.util.Comparator Comparator} implementation as a static nested class, for comparing 
	 * persons based on their names.
	 */
	public static class StaticNameComparator implements Comparator<Person> {

		/**
		 * Compares two persons' names for ascending order sorting.
		 * @param o1 the first Person to be compared
		 * @param o2 the second Person to be compared
		 * @return a negative integer, zero, or a positive integer as the first
		 *         argument is less than, equal to, or greater than the second.
		 */
		@Override
		public int compare(Person o1, Person o2) {
			// compare grades for ascending order sorting
			return o1.getName().compareTo(o2.getName());			
		}		
	}
	
	@Override
	public String toString(){
		return String.format("Person %s", name);
	}
	
}
