package ex1;

import java.util.Comparator;

/**
 *	Class that represents a student.
 */
public class Student extends Person{
	
	private Integer grade;
	
	public Student(){}
	
	public Student(String name){
		super(name);
	}

	public Student(String name, Integer grade){
		super(name);
		this.grade = grade;
	}
	
	public Integer getGrade() {
		return grade;
	}

	public void setGrade(Integer grade) {
		this.grade = grade;
	}
	
	@Override
	public String toString(){
		return String.format("Student %s, grade %s", name, grade);
	}
	
	/**
	 * {@link java.util.Comparator Comparator} implementation for comparing students based on grades.
	 * 
	 */
	public class GradeComparator implements Comparator<Student> {
		
		/**
		 * Compares two students' grades for descending order sorting.
		 * @param o1 the first Student to be compared
		 * @param o2 the second Student to be compared
		 * @return a negative integer, zero, or a positive integer as the first
		 *         argument is less than, equal to, or greater than the second.
		 */
		@Override  
		public int compare(Student o1, Student o2) {
			
			return -o1.getGrade().compareTo(o2.getGrade());			
		}		
	}
	
	/**
	 * {@link java.util.Comparator Comparator} implementation as a static nested class, for comparing 
	 * students based on grades.
	 */
	public static class StaticGradeComparator implements Comparator<Student> {

		/**
		 * Compares two students' grades for descending order sorting.
		 * @param o1 the first Student instance
		 * @param o2 the second Student instance
		 * @return a negative integer, zero, or a positive integer as the first
		 *         argument is less than, equal to, or greater than the second.
		 */
		@Override
		public int compare(Student o1, Student o2) {			
			return -o1.getGrade().compareTo(o2.getGrade());			
		}		
	}
}
