package ex2;


/**
 * Abstract class for list related events. 
 */

public abstract class ListEvent {

	private EventType type;
	

	public ListEvent(EventType type){
		this.type = type;
	}
	
	/**
	 * Provides the list on which the event happened.
	 * 
	 * @return the list
	 */

	@SuppressWarnings("rawtypes")  //because we haven't done Generics lab yet 
							 //it should have been MyArrayList<E>, ListEvent<E>
	public abstract MyArrayList getList();
	
	/**
	 * Provides the list element involved in the event.
	 * 
	 * @return the element used/obtained in the operation that generated the 
	 * 			event
	 */
	public abstract Object getElement();
	
	/**
	 * Provides the duration of the event. 
	 * 
	 * @return the number of nanoseconds
	 */
	public abstract long getDuration();
	
	/**
	 * Getter for the event's type.
	 * @return the event's type
	 */
	public EventType getType() {
		return type;
	}
	
	/**
	 * Setter for the event's type.
	 * @param type the list event's type
	 */
	public void setType(EventType type) {
		this.type = type;
	}	
	
}

enum EventType {
	ADD, REMOVE, SET
}

